#!/usr/bin/perl -w

# Copyright (C) 2000 Julian T. J. Midgley <jtjm@xenoclast.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# A copy of version 2 of the GNU General Public License may be found
# in the file "LICENCE" in the original Agnostos installation driectory.

use taskman_lib;
use strict;
use CGI;

my $dbh   = dbserver_connect('agnostos');
my $query = new CGI;
my $dbq;
my $action   = $query -> param('action');
my $todoid   = $query -> param('todoid');
my $title    = $query -> param('title');
my $status   = $query -> param('status');
my $priority = $query -> param('priority');
my $userid   = $query -> param('userid');
my $groupid  = $query -> param('groupid');
my $depid    = $query -> param('depid');
my $desc     = $query -> param('desc');
my $note     = $query -> param('note');
my $day      = $query -> param('day');
my $month    = $query -> param('month');
my $year     = $query -> param('year');
my $nodate   = $query -> param('nodate');
my $insdate;
if ( (defined $nodate)  && ($nodate eq 'true') ) {
    $insdate = 'NULL';
}
else {
    $insdate = "'$year-$month-$day'";
}
$title = sql_quote($title);
$note  = sql_quote($note);
$desc  = sql_quote($desc);

if ($action eq 'update')  {
    $dbq = $dbh -> prepare ("UPDATE todo ".
			    "SET title       = '$title', ".
			    "    status      = '$status', ".
			    "    priority    = $priority, ".
			    "    description = '$desc', ".
			    "    note        = '$note', ".
			    "    date        = $insdate, ".
			    "    completed_date = NOW() ".
			    "WHERE todoid = $todoid");
    $dbq -> execute;
    $dbq -> finish;
    $dbq = $dbh -> prepare ("UPDATE assigned ".
			    "SET userid  = $userid, ".
			    "    groupid = $groupid, ".
			    "    depid   = $depid ".
			    "WHERE todoid = $todoid");
    $dbq -> execute;
    $dbq -> finish;

    print $query -> header();
    print "\n<html><head><meta http-equiv=Refresh content=\"0; URL=view_tasks.pl\">".
	"<title>Updated Task</title></head><body bgcolor=white>\n";

    print "<h2>Task Updated</h2>";
    print html_footer;

}
else {
    $dbq = $dbh -> prepare ("INSERT INTO todo ".
			    "( title, status, priority, description, note, date ) ".
			    "VALUES ".
			    "( '$title', '$status', $priority, '$desc', '$note', $insdate )");
    $dbq -> execute;
    $todoid = $dbh -> {'mysql_insertid'};
    $dbq -> finish;

    $dbq = $dbh -> prepare ("INSERT INTO assigned ".
			    "( todoid, userid, groupid, depid ) ".
			    "VALUES ".
			    "( $todoid, $userid, $groupid, $depid )");
    $dbq -> execute;
    $dbq -> finish;
    print "\n<html><head><meta http-equiv=Refresh content=\"0; URL=view_tasks.pl\">".
	"<title>Updated Task</title></head><body bgcolor=white>\n";

    print "<h2>Task Added</h2>";
    print html_footer;
}
			    

$dbh -> disconnect;
